import { querySingle, patientUpdate } from "../patient-detail/service";
import history from "../../utils/history";
import EventHub from "../../../abMall/utils/eventEmitter";

Component({
	props: {},
	data: {
		patient: {
			balance: 0,
			id: "",
			name: "",
			age: "",
			sex: "",
			phoneNumber: "",
			birthDay: "",
			idCardNo: "",
			relationShip: "",
			bindCardNum: "",
			medicCards: [],
		},
	},

	didMount() {
		this.querySingle();
		this.onEventChange();
		// this.$page.updatePatient = this;
		// const page = getCurrentPages();
		// console.log("page", this.$page);
		// console.log("page ===>", page);
	},

	didUnmount() {
		this.onEventRemove();
	},

	methods: {
		onEventChange() {
			const _this = this;
			EventHub.addEventListener("onPatienDetailUpdate", (payload) => {
				if (payload) {
					_this.querySingle();
				}
			});
		},
		onEventRemove() {
			const _this = this;
			EventHub.removeEventListener("onPatienDetailUpdate", (payload) => {
				if (payload) {
					_this.querySingle();
				}
			});
		},
		querySingle() {
			const {
				query = {
					id: "",
				},
			} = this.$page.data;
			my.showLoading();
			querySingle({
				id: query.id,
			}).then((data) => {
				this.setData({
					patient: data,
				});
				my.hideLoading();
			});
		},

		// 修改关系
		onChange(e) {
			this.setData({
				"patient.relationShip": e.name,
			});
		},

		onChangePhone() {
			history.push({
				query: {
					id: this.data.patient.id,
          relationShip: this.data.patient.relationShip,
				},
				title: "修改手机号",
				pageType: "patient-detail-phone",
			});
		},

		onSubmit() {
			patientUpdate({
				id: this.data.patient.id,
				name: this.data.patient.name,
				relationShip: this.data.patient.relationShip,
			}).then(my.navigateBack);
		},
	},
});
